#include <stdio.h>
#include <allegro.h>

#include "prjxmain.h"
#include "map.h"

int MAP_MovePlayer(int pdir)
{
   switch(pdir)
   {
      case 0:                    // *!* UP
         if(PL_player.y > 14)
         {
            PL_player.y -=1;
            MAP_DisplayMap();
         }
         break;
      case 1:                    // *!* DOWN
         if(PL_player.y < 490)
         {
            PL_player.y += 1;
            MAP_DisplayMap();
         }
         break;
      case 2:                    // *!* LEFT
         if(PL_player.x > 18)
         {
            PL_player.x -= 1;
            MAP_DisplayMap();
         }
         break;
      case 3:                    // *!* RIGHT
        if(KeyWay < 490)
         {
            PL_player.x += 1;
            MAP_DisplayMap();
         }
         break;
   }
   return(0);
}

int MAP_LoadBG(void)
{
   PALLETE pallete1;

   TGA_MapBG=load_bitmap("GRAFIX\\MAP_BG.TGA",pallete1);
   return(0);
}

int MAP_CheckLocation(void)
{
   int temp1;

   for(temp1=0;temp1<150;temp1++)
   {
      if((PL_player.x+8)==PL_enemy[temp1].x && (PL_player.y+5)==PL_enemy[temp1].y)
      {
         switch(PL_enemy[temp1].type)
         {
            case 1:
               PL_player.hp-=5;
               playwav("AUDIO\\DOH.WAV");
               return(0);
               break;
         }
      }
   }
   return(0);
}


int MAP_DisplayBG(void)
{
   blit(TGA_MapBG,screen,0,0,0,0,320,200);
   return(0);
}


int MAP_LoadMap(void)
{
   PACKFILE *infile;
   int temp1,temp2;

   infile = pack_fopen("DAT\\MAP.DAT", "rp");
   if (infile == NULL)
   {
      return(0);
   }
   pack_fread(&Map,sizeof(Map),infile);
   pack_fclose(infile);
   return(0);
}

int MAP_LoadTiles(void)
{
   int tempX,tempY,tmptile;
   PALLETE pallete1;

   tmptile=0;

   TGA_MapTiles=load_bitmap("GRAFIX\\MAPTILES.TGA",pallete1);
   for(tempY=0;tempY<192;tempY+=16)
   {
      for(tempX=0;tempX<320;tempX+=16)
      {
         TGA_Tileset[tmptile]=load_bitmap("GRAFIX\\BL_16X16.TGA",pallete1);
         blit(TGA_MapTiles,TGA_Tileset[tmptile],tempX,tempY,0,0,16,16);
         tmptile++;
      }
   }
   return(0);
}

int MAP_LoadGame(void)
{

   return(0);
}

int MAP_LoadEnemies(void)
{
   int tempX,tempY,temp1;

   temp1=0;
   for(tempY=0;tempY<500;tempY++)
      for(tempX=0;tempX<500;tempX++)
      {
         if(Map[tempX][tempY].enemy>0)
         {
            PL_enemy[temp1].type=Map[tempX][tempY].enemy;
            PL_enemy[temp1].x=tempX;
            PL_enemy[temp1].y=tempY;
            PL_enemy[temp1].hp=30;
            PL_enemy[temp1].mp=0;
            PL_enemy[temp1].direction=rand()%4;
            temp1++;
         }
      }
   return(0);
}

int MAP_SaveGame(void)
{

   return(0);
}


int MAP_DisplayMap(void)
{
   int tempX,tempY,temp1;

   showtranspict("GRAFIX\\BL_16X16.TGA",0,0,5,55,150,59);
   for(tempY=0;tempY<10;tempY++)
   {
      for(tempX=0;tempX<17;tempX++)
      {
         blit(TGA_Tileset[Map[(tempX)+PL_player.x][(tempY)+PL_player.y].tile],screen,0,0,tempX*16,tempY*16,16,16);
         masked_blit(TGA_Tileset[Map[(tempX)+PL_player.x][(tempY)+PL_player.y].layer2],screen,0,0,tempX*16,tempY*16,16,16);
         MAP_ShowEnemy(tempX,tempY);
      }
   }
   return(0);
}

int MAP_ShowEnemy(int tempX,int tempY)
{
   int temp1;

   for(temp1=0;temp1<150;temp1++)
   {
      if(PL_enemy[temp1].x==(tempX+PL_player.x) && PL_enemy[temp1].y==(tempY+PL_player.y))
      {
         switch(PL_enemy[temp1].type)
         {
            case 1:
               textout(screen,font,"E",(tempX*16)+4,(tempY*16)+4,COLOR_WHITE);
               break;
         }
      }
   }
   return(0);
}


int MAP_ShowPlayer(int direction)
{
/*
   NOTE:  To find out exactly which tile the player is standing on, use
   the formula of:
      Map[PL_player.x+8][PL_player.y+5].tile=0;
   the Map[PL_player.x][PL_player.y].tile is at the top left of the screen,
   therefore, add 8x and 5y to the equation and you have the location of
   the player :)
*/
   switch(direction)
   {
      case 0: //up
         masked_blit(TGA_MapPlayerUP,screen,0,0,128,72,16,24);
         PL_player.direction=0;
         break;
      case 1: //down
         masked_blit(TGA_MapPlayerDOWN,screen,0,0,128,72,16,24);
         PL_player.direction=1;
         break;
      case 2: //left
         masked_blit(TGA_MapPlayerLEFT,screen,0,0,128,72,16,24);
         PL_player.direction=2;
         break;
      case 3: //right
         masked_blit(TGA_MapPlayerRIGHT,screen,0,0,128,72,16,24);
         PL_player.direction=3;
         break;
   }         
   return(0);
} 


int MAP_MoveEnemies(void)
{
   int temp1;
   int RandNum1, RandNum2;

   for(temp1=0;temp1<150;temp1++)
   {
      switch(PL_enemy[temp1].type)
      {
         case 1:
            RandNum1=rand()%5;  //If it's not going to go towards the guy, make it go in a random direction
            RandNum2=rand()%3;  //Randomize the Simple AI...if it's 0 or 1 it'll go towards the player in the direction x or y respectively  
            switch(RandNum2)    
            {
               case 0:
                  if(PL_enemy[temp1].x > (PL_player.x+8))
                     RandNum1=2;
                  if(PL_enemy[temp1].x < (PL_player.x+8))
                     RandNum1=3;
                  break;
               case 1:
                  if(PL_enemy[temp1].y > (PL_player.y+5))
                     RandNum1=0;
                  if(PL_enemy[temp1].y < (PL_player.y+5))
                     RandNum1=1;
                     break;
            }
            switch(RandNum1)   //da random number chose which way the enemy will move
            {
               case 0:  //enemy went up
                  if(Map[PL_enemy[temp1].x][PL_enemy[temp1].y-1].walk==1)
                  {
                     PL_enemy[temp1].y--;
                  }
                  break;
               case 1:  //enemy went down
                  if(Map[PL_enemy[temp1].x][PL_enemy[temp1].y+1].walk==1)
                  {
                     PL_enemy[temp1].y++;
                  }
                  break;
               case 2:  //enemy went left
                  if(Map[PL_enemy[temp1].x-1][PL_enemy[temp1].y].walk==1)
                  {
                     PL_enemy[temp1].x--;
                  }
                  break;
               case 3:  //enemy went right
                  if(Map[PL_enemy[temp1].x+1][PL_enemy[temp1].y].walk==1)
                  {
                     PL_enemy[temp1].x++;
                  }
                  break;
            }
            break;
      }
   }
   return(0);
}


int MAP_ShootEnemy(void)
{
   int pTmp, temp1;

   if(PL_player.ammo>0)
   {
      for(temp1=0;temp1<150;temp1++)
      {
         switch(PL_enemy[temp1].type)
         {
            case 1:
               switch(PL_player.direction)
               {
                  case 0:     //up down left right respectivly
                     for(pTmp=0;pTmp<3;pTmp++)
                     {
                        if(PL_enemy[temp1].x==(PL_player.x+8) && PL_enemy[temp1].y==(PL_player.y+5-pTmp))
                        {
                           PL_enemy[temp1].hp -= 10;
                           if(PL_enemy[temp1].hp < 0)
                           {
                              MAP_DoDeadEnemy(temp1);
                           } else
                           {
                              textprintf(screen,font,1,170,COLOR_YELLOW,"Enemy Stats: X%i Y%i  HP:%i MP:%i",PL_enemy[temp1].x,PL_enemy[temp1].y,PL_enemy[temp1].hp,PL_enemy[temp1].mp);
                           }
                        }
                        circlefill(screen,136,72-(pTmp*8),3,COLOR_WHITE);
                     }
                     break;
                  case 1:
                     for(pTmp=0;pTmp<3;pTmp++)
                     {
                        if(PL_enemy[temp1].x==(PL_player.x+8) && PL_enemy[temp1].y==(PL_player.y+5+pTmp))
                        {
                           PL_enemy[temp1].hp -= 10;
                           if(PL_enemy[temp1].hp < 0)
                           {
                              MAP_DoDeadEnemy(temp1);
                           } else
                           {
                              textprintf(screen,font,1,170,COLOR_YELLOW,"Enemy Stats: X%i Y%i  HP:%i MP:%i",PL_enemy[temp1].x,PL_enemy[temp1].y,PL_enemy[temp1].hp,PL_enemy[temp1].mp);
                           }
                        }
                        circlefill(screen,136,104+(pTmp*8),3,COLOR_WHITE);
                     }
                     break;
                  case 2:
                     for(pTmp=0;pTmp<3;pTmp++)
                     {
                        if(PL_enemy[temp1].x==(PL_player.x+8-pTmp) && PL_enemy[temp1].y==(PL_player.y+5))
                        {
                           PL_enemy[temp1].hp -= 10;
                           if(PL_enemy[temp1].hp < 0)
                           {
                              MAP_DoDeadEnemy(temp1);
                           } else
                           {
                              textprintf(screen,font,1,170,COLOR_YELLOW,"Enemy Stats: X%i Y%i  HP:%i MP:%i",PL_enemy[temp1].x,PL_enemy[temp1].y,PL_enemy[temp1].hp,PL_enemy[temp1].mp);
                           }
                        }
                        circlefill(screen,104+(pTmp*8),88,3,COLOR_WHITE);
                     }
                     break;
                  case 3:
                     for(pTmp=0;pTmp<3;pTmp++)
                     {
                        if(PL_enemy[temp1].x==(PL_player.x+8+pTmp) && PL_enemy[temp1].y==(PL_player.y+5))
                        {
                           PL_enemy[temp1].hp -= 10;
                           if(PL_enemy[temp1].hp < 0)
                           {
                              MAP_DoDeadEnemy(temp1);
                           } else
                           {
                              textprintf(screen,font,1,170,COLOR_YELLOW,"Enemy Stats: X%i Y%i  HP:%i MP:%i",PL_enemy[temp1].x,PL_enemy[temp1].y,PL_enemy[temp1].hp,PL_enemy[temp1].mp);
                           }
                        }
                        circlefill(screen,152+(pTmp*8),88,3,COLOR_WHITE);
                     }
                     break;
               }
         }
      }
      playwav("AUDIO\\GUN1.WAV");
      PL_player.ammo--;
   }
   rest(100);
   return(0);
}

int MAP_DoDeadEnemy(int temp1)
{
   int randX, randY;

   if(PL_enemy[temp1].hp <= 0)
   {
      PL_enemy[temp1].type = 0;  //if he's dead, he's dead
      if(PL_player.ammo < 990)
         PL_player.ammo += 5; //give him a few bullets for his accomplishments :)
      while(PL_enemy[temp1].type==0)
      {
         randX=(rand()%20)+(PL_enemy[temp1].x-10);
         randY=(rand()%20)+(PL_enemy[temp1].y-10);
         if((Map[randX][randY].walk==1) && (randX > 5) && (randY > 5))
         {
            PL_enemy[temp1].x=randX;
            PL_enemy[temp1].y=randY;
            PL_enemy[temp1].hp=30;
            PL_enemy[temp1].mp=0;
            PL_enemy[temp1].type=1;
         }
      }
   }
}
